#!/usr/bin/perl

use warnings;
use strict;

use Socket qw(:DEFAULT inet_ntop inet_pton getnameinfo);

die "Usage: $0 [address] [port]" if (not $ARGV[0] and not $ARGV[1]);

my $straddr = ($ARGV[0] or "0.0.0.0");
my $port = ($ARGV[1] or 0);

# pack address + port

my $sockaddr;

# note that we assume the address is correct,
# real code should verify that

# stupid way to detect address family
if ($straddr =~ /:/) {
  $sockaddr = sockaddr_in6($port, inet_pton(AF_INET6, $straddr));
} else {
  $sockaddr = sockaddr_in($port, inet_pton(AF_INET, $straddr));
}

# do the inverse resolution 

my $flags = 0;
my $xflags = 0;

my ($err, $hostname, $servicename) = getnameinfo($sockaddr, $flags, $xflags);

die "getnameinfo: error or no results" if $err;

# dump
print "hostname: $hostname, servicename: $servicename\n";
